//
//  920MHz LoRa/FSK RF module ES920LR3 
//
//  MaiaR create
//

#include "LoRa.h"

int ResetPin = 8;

void LoRaReset(){
  pinMode(ResetPin, OUTPUT); // NRST "L"
  digitalWrite(ResetPin, LOW);
  delay(1000);
  pinMode(ResetPin, INPUT);  // NRST open
}

int LoRaCommand(String s){
  Serial.print(s + "\r\n");
  Serial.flush();
  String rx = Serial.readString();
  return (rx.indexOf("OK"));
}

void LoRaConfigMode(){
  while(1){
    LoRaReset();
    String rx = Serial.readString();
    if (rx.indexOf("Select Mode") >= 0) break;
    LoRaCommand("config");
  }
}


int LoRaInit(){
  Serial.begin(115200);
  Serial.setTimeout(50);
  LoRaConfigMode();
  if (LoRaCommand("2"     ) < 0) return(-1); // processor mode
  if (LoRaCommand("x"     ) < 0) return(-1); // default
  if (LoRaCommand("c 12"  ) < 0) return(-1); // spread factor
  if (LoRaCommand("d 3"   ) < 0) return(-1); // channel
  if (LoRaCommand("e 2345") < 0) return(-1); // PAN ID
  if (LoRaCommand("f 0"   ) < 0) return(-1); // own ID
  if (LoRaCommand("g ffff") < 0) return(-1); // broadcast
  if (LoRaCommand("p 1"   ) < 0) return(-1); // RSSI on
  if (LoRaCommand("z"     ) < 0) return(-1); // start
  return(0);
}
